#ifndef AREACFG_H_
#define AREACFG_H_

#include "gType.h" 
#include "GraphBase.h"
#include "string.h"
#include "my_string.h"
#include "Device.h"
#include "EpDevice.h"
#include "StaticText.h"
#include "CtlPanel1.h"
#include "EditML.h"

//#pragma pack(push, 1)

class TAreaCfg{
	public:
		static constexpr unsigned short hList[12] = {82,140,82,48,	32,32,32,32,	32,32,32,32};
		static constexpr unsigned short wList[12] = {800,290,290,290,	800,800,800,800,	800,800,800,800};
		static constexpr TLv Lv = {
			.Caption.Left = 0,
			.Caption.Top = 36,
			.Caption.Width = 800,
			.Caption.Heigh = 32,
			.Caption.Right = 800 -0 -1,
			.Caption.Bottom = 36 + 32,
			
			.Grid.Left = {0,0,0,0,	0,0,0,0,	0,0,0,0},
			.Grid.Right = {wList[0]-1,wList[1]-1,wList[2]-1,wList[3]-1,	wList[4]-1,wList[5]-1,wList[6]-1,wList[7]-1,	wList[8]-1,wList[9]-1,wList[10]-1,wList[11]-1},
			.Grid.Top[0] = (36 + 32 +8),
			.Grid.Top[1] = (36 + 32 +8) + (2 + hList[0]),
			.Grid.Top[2] = (36 + 32 +8) + (2 + hList[0]) + (2 + hList[1]),
			.Grid.Top[3] = (36 + 32 +8) + (2 + hList[0]) + (2 + hList[1]) + (2 + hList[2]),
				
			.Grid.Bottom[0] = (36 + 32 +8) + hList[0],
			.Grid.Bottom[1] = (36 + 32 +8) + (2 + hList[0]) + hList[1],
			.Grid.Bottom[2] = (36 + 32 +8) + (2 + hList[0]) + (2 + hList[1]) + hList[2],
			.Grid.Bottom[3] = (36 + 32 +8) + (2 + hList[0]) + (2 + hList[1]) + (2 + hList[2]) + hList[3],
			
			.Grid.UsingCount = 4,
				
			.Panel.ItemType = piMemo,
			.Panel.Left = wList[1] + 6,
			.Panel.Top = (36 + 32 +2) + hList[0] +12,
			.Panel.Width = 502,
			.Panel.Heigh = 278,
			.Panel.Right = wList[1] + 6 + 502 -1,
			.Panel.Bottom = (36 + 32 +2) + hList[0] +6 + 278 -1,
			
			.Panel.Active = 1,
			.Panel.ItemType = piMemo,
			.PanelSmall.Active = 0,
		};
		static constexpr TPoint ResultTipPoint = {
			.x = Lv.Grid.Left[3] + 10,
			.y = Lv.Grid.Top[3] + 6,
		};
	public:
		int IsShow;
		class TEditML	mlEdit;
		class TItemList	*IList;
		class TCtlPanel1	*aPanel;
	
		unsigned int ItemInx;
		unsigned char IsList;
		unsigned char IsPermission;
		unsigned char PermissionCmd;
		
		unsigned int CtlIndex;
		
		int Sta;
		
		char RawData[64];
		char UserCodeStr[8];
	
		unsigned char IsEdittingDescp;
		unsigned char IsExtInput;
		unsigned char IsEdittingShortName;
	
		int ItemCount;
		int ListPage;
		char ListText[20];
	public:
		TAreaCfg(){};
		void Init();
		static void sDelayMs(unsigned int aMs);
		
		void RenderBackGround(void);
		void RenderBackGround(unsigned int aClr);
		void DrawSelf(void);
		void DrawFixText();
		
		void Show(void);
		void ReDraw(void);
		void FullRedraw(int Prm);
		void ShowCfg();
		void ShowSta();
		void ShowSta(int aSta);
		void Redraw4EditText();
		void DrawCount();
		void DrawList();
		void Start();
		
		TGuiMsgReturn KeyIn(unsigned char aKey);
		
		void InitPanel(char *pText);
		void ClearSelected(void);
		void Check4Selected(void);
		
		void CheckCount();
		void LoadUcBcdText();
		void LoadShortName();
		void LoadDescp();
		void LoadData();
		
		void RestoreUcBcdText();
		void RestoreShortName();
		void RestoreDescp();
		void RestoreData();
		
		void RestoreShortName(char *p);
		void RestoreDescp(char *p);
		
		void PermissionCmdGO();
		void PermissionCmdReturnDraw();
			
		void ReadAllFromFlash();
		void ReadEntryViaFlash();
		void WriteEntryViaFlash();
		
		void NewEntry();
		
		static void sRecoverSetDefault();
		
		int ExtRequst(unsigned char Prm){IsShow =0; return 0;}
	
};

























//#pragma pack(pop)



#endif

